;; From: Michael Slass <mikesl@wrq.com>
;; Subject: Re: Text processing Java source code
;; Newsgroups: comp.emacs,comp.emacs.xemacs,comp.lang.java.softwaretools
;; Date: Wed Jul 31 23:39:08 2002 +0400
;; Organization: Verio
;;
;; Roedy Green <roedy@mindprod.com> writes:
;;
;; >On 27 Jul 2002 01:32:25 -0700, cmaj10@yahoo.com (Christophe Major)
;; >wrote or quoted :
;; >
;; >>I have to write a script that will take Java source code as input and
;; >>will output the code stripped of all its comments.
;; >
;; >I would be happy to write you one for $50 US.
;; >
;;
;; Sorry, that made me do it for free.
;;
;; Try this for a start.  I leave the reading of files writing them back
;; out again for the OP as an excersize.

(defun delete-all-comments (&optional buffer)
   "Delete all comments from the current buffer.
Buffer must be fontified -- this function deletes all chars whose
text-properties include font-lock-comment-face.

With optional arg BUFFER, apply to buffer instead."
  (interactive "bDelete comments from buffer: ")
  (if buffer (set-buffer buffer))
  (if (not font-lock-fontified)
      (error "The buffer in question must be fontified in order to delete all comments."))
  (beginning-of-buffer)
  (while (not (eobp))
    (let ((beg))
      (while (not (or (memq font-lock-comment-face (text-properties-at (point)))
                      (eobp)))
        (forward-char 1))
      (when (not (eobp))
        (setq beg (point))
        (while (and (memq font-lock-comment-face (text-properties-at (point)))
                    (not (eobp)))
          (forward-char 1))
        (delete-region beg (point))))))
