;; AFAIK, GNU Emacs 21 does not have find-library functionality by default.
;; This is a quick and poor, but sufficient for my needs implementation.
;; It was tested on GNU Emacs 21.3.
;;
;; Public domain. Originally by Vasily Korytov.

;; You may want to copy this in your ~/.emacs:
;;
;; (autoload 'find-library "find-library" nil t)
;; (autoload 'find-library-other-frame "find-library" nil t)
;; (autoload 'find-library-other-window "find-library" nil t)

;;;###autoload
(defun find-library (arg &optional function)
  "A poor man's find-library: opens the {arg}.el or {arg} entry in `load-path'.
This command uses `find-file' or the second argument to do so."
  (interactive "sLibrary to find: ")
  (let ((file (or (locate-library (concat arg ".el"))
		  (locate-library arg))))
    (if file
	(funcall (or function 'find-file) file)
      (message (concat "No " arg " in load-path."))
      nil)))

;;;###autoload
(defun find-library-other-frame (arg)
  "A poor man's find-library: opens the {arg}.el or {arg} entry in `load-path'.
This command uses `find-file-other-frame' to do so."
  (interactive "sLibrary to find: ")
  (find-library arg 'find-file-other-frame))

;;;###autoload
(defun find-library-other-window (arg)
  "A poor man's find-library: opens the {arg}.el or {arg} entry in `load-path'.
This command uses `find-file-other-window' to do so."
  (interactive "sLibrary to find: ")
  (find-library arg 'find-file-other-window))

(provide 'find-library)
