;; isearch in XEmacs (at least, up to 21.4.11) is broken: in modes, that
;; have (suppress-keymap ...) in their map, it can accept only ASCII
;; letters. This hack seems to fix it.

;; Public domain. Originally by Vasily Korytov.

;; I use Russian letters and keysums. If you don't, change this:
;;
(defvar self-insert-list
  (list
   'Cyrillic_IO '
   'Cyrillic_io '
   'Cyrillic_SHORTI '
   'Cyrillic_shorti '
   'Cyrillic_TSE '
   'Cyrillic_tse '
   'Cyrillic_U '
   'Cyrillic_u '
   'Cyrillic_KA '
   'Cyrillic_ka '
   'Cyrillic_IE '
   'Cyrillic_ie '
   'Cyrillic_EN '
   'Cyrillic_en '
   'Cyrillic_GHE '
   'Cyrillic_ghe '
   'Cyrillic_SHA '
   'Cyrillic_sha '
   'Cyrillic_SHCHA '
   'Cyrillic_shcha '
   'Cyrillic_ZE '
   'Cyrillic_ze '
   'Cyrillic_HA '
   'Cyrillic_ha '
   'Cyrillic_HARDSIGN '
   'Cyrillic_hardsign '

   'Cyrillic_EF '
   'Cyrillic_ef '
   'Cyrillic_YERU '
   'Cyrillic_yeru '
   'Cyrillic_VE '
   'Cyrillic_ve '
   'Cyrillic_A '
   'Cyrillic_a '
   'Cyrillic_PE '
   'Cyrillic_pe '
   'Cyrillic_ER '
   'Cyrillic_er '
   'Cyrillic_O '
   'Cyrillic_o '
   'Cyrillic_EL '
   'Cyrillic_el '
   'Cyrillic_DE '
   'Cyrillic_de '
   'Cyrillic_ZHE '
   'Cyrillic_zhe '
   'Cyrillic_E '
   'Cyrillic_e '

   'Cyrillic_YA '
   'Cyrillic_ya '
   'Cyrillic_CHE '
   'Cyrillic_che '
   'Cyrillic_ES '
   'Cyrillic_es '
   'Cyrillic_EM '
   'Cyrillic_em '
   'Cyrillic_I '
   'Cyrillic_i '
   'Cyrillic_TE '
   'Cyrillic_te '
   'Cyrillic_SOFTSIGN '
   'Cyrillic_softsign '
   'Cyrillic_BE '
   'Cyrillic_be '
   'Cyrillic_YU '
   'Cyrillic_yu '
   )
  "List of non-ASCII letters and keysums, that are in use.")

(let ((list self-insert-list))
      (while list
	(define-key isearch-mode-map (car list) 'isearch-printing-char)
	(setq list (cdr list))))

(provide 'isearch-vk-fix-keymap)
