;; Scroll on mouse wheel (both GNU Emacs and XEmacs)
;; based on code from http://www-sop.inria.fr/koala/colas/mouse-wheel-scroll/

;; check, if we're running XEmacs
(if (featurep 'xemacs)
    (progn
      (define-key global-map 'button4
	'(lambda (&rest args)
	   (interactive)
	   (let ((curwin (selected-window)))
	     (select-window (car (mouse-pixel-position)))
	     (scroll-down 5)
	     (select-window curwin))))

      (define-key global-map [(shift button4)]
	'(lambda (&rest args)
	   (interactive)
	   (let ((curwin (selected-window)))
	     (select-window (car (mouse-pixel-position)))
	     (scroll-down 1)
	     (select-window curwin))))

      (define-key global-map [(control button4)]
	'(lambda (&rest args)                   
	   (interactive)
	   (let ((curwin (selected-window)))
	     (select-window (car (mouse-pixel-position)))
	     (scroll-down)
	     (select-window curwin))))

      (define-key global-map 'button5
	'(lambda (&rest args)
	   (interactive)
	   (let ((curwin (selected-window)))
	     (select-window (car (mouse-pixel-position)))
	     (scroll-up 5)
	     (select-window curwin))))

      (define-key global-map [(shift button5)]
	'(lambda (&rest args)
	   (interactive)
	   (let ((curwin (selected-window)))
	     (select-window (car (mouse-pixel-position)))
	     (scroll-up 1)
	     (select-window curwin))))

      (define-key global-map [(control button5)]
	'(lambda (&rest args)
	   (interactive)
	   (let ((curwin (selected-window)))
	     (select-window (car (mouse-pixel-position)))
	     (scroll-up)
	     (select-window curwin)))))

  ;; not XEmacs? Probably, we have GNU Emacs then.
  (defun scroll-up-half ()
    "Scroll up half a page."
    (interactive)
    (scroll-up (/ (window-height) 2)))

  (defun scroll-down-half ()
    "Scroll down half a page."
    (interactive)
    (scroll-down (/ (window-height) 2)))

  (defun scroll-up-one ()
    "Scroll up one line."
    (interactive)
    (scroll-up 1))

  (defun scroll-down-one ()
    "Scroll down one line."
    (interactive)
    (scroll-down 1))

  (defun scroll-up-slightly ()
    "Scroll down 5 lines."
    (interactive)
    (scroll-up 5))

  (defun scroll-down-slightly ()
    "Scroll down 5 lines."
    (interactive)
    (scroll-down 5))

  (global-set-key [(control mouse-5)] 'scroll-up)
  (global-set-key [(control mouse-4)] 'scroll-down)

  (global-set-key [(mouse-5)] 'scroll-up-slightly)
  (global-set-key [(mouse-4)] 'scroll-down-slightly)

  (global-set-key [(shift mouse-5)] 'scroll-up-one)
  (global-set-key [(shift mouse-4)] 'scroll-down-one))

(provide 'mouse-wheel)
